###### Communities and crime

data<-read.csv("/Users/Thierry/Documents/R/Data/Communities_and_crime/communities.data",
               sep = ",",header=TRUE)
names(data)[128]<-"crime"
data<-data[,-(1:5)]
data$crime<-log(data$crime+0.1)

nbna<-rep(0,123)
for(i in 1:123) nbna[i]<-length(which(is.na(data[,i])))
j<-which(nbna==1)
data[which(is.na(data[,j])),j]<-mean(data[,j],na.rm =TRUE)
data<-data[,nbna<=1]

n<-nrow(data)
ntrain<-round(2*n/3)
ntest<-n-ntrain
train<-sample(n,ntrain)
data.train<-data[train,]
data.test<-data[-train,]
y.test<-data.test$crime
y.train<-data.train$crime

X<-model.matrix(crime~.,data=data)
X.train<-X[train,]
X.test<-X[-train,]

fit.reg<-lm(crime ~., data=data.train)
summary(fit.reg)
pred.ls<-predict(fit.reg,newdata=data.test)
mse.ls<-mean((pred.ls-y.test)^2)
print(mse.ls)
plot(y.test,pred.ls)
abline(0,1)

library(glmnet)
cv.out<-cv.glmnet(X.train[,-1],y.train,alpha=1,standardize=TRUE)
plot(cv.out)
fit1<-glmnet(X.train[,-1],y.train,lambda=cv.out$lambda.min,alpha=1,standardize=TRUE)
fit2<-glmnet(X.train[,-1],y.train,lambda=cv.out$lambda.1se,alpha=1,standardize=TRUE)
# Minimum CV error model
lasso.pred1<-predict(fit1,newx=X.test[,-1])
mse_lasso1<-mean((y.test-lasso.pred1)^2)
# One SE rule
lasso.pred2<-predict(fit2,newx=X.test[,-1])
mse_lasso2<-mean((y.test-lasso.pred2)^2)

print(c(mse.ls,mse_lasso1,mse_lasso2))

# RF

fit.rf<-randomForest(crime~.,data=data.train,importance=TRUE)
pred.rf<-predict(fit.rf,newdata=data.test)
mse.rf<-mean((y.test-pred.rf)^2)
print(c(mse.ls,mse_lasso1,mse_lasso2,mse.rf))

plot(y.test,pred.ls,col="blue",pch=1)
points(y.test,pred.rf,col="red",pch=2)
abline(0,1)
varImpPlot(fit.rf)

## NN
fit<-nnet(crime ~. ,size=20,decay=1,data=data.train,linout = TRUE,MaxNWts = 10000)
pred.nn<-predict(fit,newdata=data.test)
mse.nn<-mean((y.test-pred.nn)^2)
print(mse.nn)
print(c(mse.ls,mse_lasso1,mse_lasso2,mse.rf,mse.nn))
